#include <stdio.h>
#include <stdlib.h>

String blueToothVal;           //value sent over via bluetooth

//stores last state of device (on/off)

//motor one
int enA = 10;
int in1 = 9;
int in2 = 8;
// motor two
int enB = 5;
int in3 = 7;
int in4 = 6;

int motorSpeed  = 200;
 
void setup()
{
 Serial.begin(9600); 
 pinMode(13,OUTPUT);
 // set all the motor control pins to outputs
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
}

void demoOne()
{
  // this function will run the motors in both directions at a fixed speed
  // turn on motor A
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  // set speed to 200 out of possible range 0~255
  analogWrite(enA, 200);
  // turn on motor B
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  // set speed to 200 out of possible range 0~255
  analogWrite(enB, 200);
  delay(2000);
  // now change motor directions
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);  
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH); 
  delay(2000);
  // now turn off motors
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);  
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
}
void demoTwo()
{
  // this function will run the motors across the range of possible speeds
  // note that maximum speed is determined by the motor itself and the operating voltage
  // the PWM values sent by analogWrite() are fractions of the maximum speed possible 
  // by your hardware
  // turn on motors
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);  
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH); 
  // accelerate from zero to maximum speed
  for (int i = 0; i < 256; i++)
  {
    analogWrite(enA, i);
    analogWrite(enB, i);
    delay(20);
  } 
  // decelerate from maximum speed to zero
  for (int i = 255; i >= 0; --i)
  {
    analogWrite(enA, i);
    analogWrite(enB, i);
    delay(20);
  } 
  // now turn off motors
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);  
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);  
}

void halt()
{
  // turn off motors
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);  
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);  
}

void leftForward()
{
  // turn on motor A
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  analogWrite(enA, motorSpeed);
}

void leftBackwards()
{
  // turn on motor A
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  analogWrite(enA, motorSpeed);
}


void rightForward()
{
  // turn on motor B
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(enB, motorSpeed);
}

void rightBackwards()
{
  // turn on motor B
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  analogWrite(enB, motorSpeed);
}

void bothForward()
{
  leftForward();
  rightForward();
}

void bothBackwards()
{
  leftBackwards();
  rightBackwards();
}


 
 
void loop()
{
  if(Serial.available())
  {//if there is data being recieved
    blueToothVal=Serial.readString(); //read it
  }
  if (blueToothVal=="forward")
  {
    Serial.println(F("moving forward"));
    bothForward();
  }
  else if (blueToothVal=="backwards")
  {
    Serial.println(F("moving backwards"));
    bothBackwards();
  }
  else if (blueToothVal=="leftfrightb")
  {
    Serial.println(F("left forward, right backwards"));
    leftForward();
    rightBackwards();
  }
  else if (blueToothVal=="leftbrightf")
  {
    Serial.println(F("left backwards, right forward"));
    rightForward();
    leftBackwards();
  }
  else if (blueToothVal=="halt")
  {
    Serial.println(F("left backwards, right forward"));
    halt();
  }
  else if (blueToothVal=="leftf")
  {
    Serial.println(F("left forward"));
    leftForward();
  }
  else if (blueToothVal=="leftb")
  {
    Serial.println(F("left backwards"));
    leftBackwards();
  }
  else if (blueToothVal=="rightf")
  {
    Serial.println(F("right forward"));
    rightForward();
  }
  else if (blueToothVal=="rightb")
  {
    Serial.println(F("right backwards"));
    rightBackwards();
  }
  else
  {
    char copy[20]; 
    strcpy(copy, blueToothVal.c_str());
    copy[sizeof(copy) - 1] = 0;
    char call[10];
    int number;

    sscanf(copy, "%s %d", call, number);

    if(call == "speed")
    {
      Serial.println(F("right backwards"));
      motorSpeed = number;
    }
  }
}
